美文网首页
[kuangbin带你飞]专题一 简单搜索 F

[kuangbin带你飞]专题一 简单搜索 F

作者: jenye_ | 来源:发表于2018-07-17 13:29 被阅读0次

    Prime Path

    The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
    — It is a matter of security to change such things every now and then, to keep the enemy in the dark.
    — But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
    — I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
    — No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
    — I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
    — Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
    Now, the minister of finance, who had been eavesdropping, intervened.
    — No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
    — Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
    — In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
    1033
    1733
    3733
    3739
    3779
    8779
    8179
    The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
    Input
    One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
    Output
    One line for each case, either with a number stating the minimal cost or containing the word Impossible.
    Sample Input
    3
    1033 8179
    1373 8017
    1033 1033
    Sample Output
    6
    7
    0

    用两种处理这个四位数,至今不知道为何之前wa两次,后来想起来用sprintf可以方便的提取各个位数。然后就A了,结论就是尽量简洁的代码,出错的可能性就越少。

    #include<iostream>
    #include<cstdio>
    #include<queue>
    #include<cstring>
    using namespace std;
    bool visited[10010];
    bool prime[10010]={false,false,false};
    int goal;
    
    int init(){
        for(int i = 2;i< 10000;i++){
            if(!prime[i]){
                for(int j = 2 ; i*j<10000;j++){
                    prime[j*i] = 1; 
                 } 
            }
        }
    }
    
    struct node{
        int num;
        int step;
    };
    
    int bfs(node start){
        queue<node> Q;
        Q.push(start);
        node nownode;
        node nextnode;
        while(!Q.empty()){
            char num[5];
            nownode = Q.front();Q.pop();
            if(nownode.num == goal){
                return nownode.step;
                break;
            }
            sprintf(num,"%d",nownode.num);
            for(int i=0;i<4;i++){
                for(int j=0;j<=9;j++){
                    if(i==0&&j==0) continue; 
                    switch(i){
                        case 0:
                                nextnode.num = j*1000 + (num[1]-'0')*100+(num[2]-'0')*10 +(num[3]-'0'); break;
                        case 1: 
                                nextnode.num = (num[0]-'0')*1000 + j*100+(num[2]-'0')*10 +(num[3]-'0'); break;
                        case 2:
                                nextnode.num = (num[0]-'0')*1000 + (num[1]-'0')*100+j*10 +(num[3]-'0'); break;
                        case 3:
                                nextnode.num = (num[0]-'0')*1000 + (num[1]-'0')*100+(num[2]-'0')*10 +j; break;      
                    }
                    
                    if(!visited[nextnode.num]&&!prime[nextnode.num]){
    //                  cout<<"next"<<nextnode.num<<endl;
    //              cout<<"now"<<nownode.num<<endl;
                        visited[nextnode.num]=true;
                        nextnode.step = nownode.step + 1;
                        
                        Q.push(nextnode); 
                    }
                } 
            }
            nextnode.step = nownode.step ++;
            
        }
        
        return -1;
        
    }
    int main() {
        int T;
        cin>>T;
        init();
        while(T--){
            node start;
            cin>>start.num>>goal;
            memset(visited,false,sizeof(visited));
            start.step = 0;
            int ans = bfs(start);
            if(ans == -1)
                cout<<"Impossible"<<endl;
            else
                cout<<ans<<endl;    
        }   
        return 0;
    }
    

    相关文章

      网友评论

          本文标题:[kuangbin带你飞]专题一 简单搜索 F

          本文链接:https://www.haomeiwen.com/subject/nkiwpftx.html